package fr.username404.snowygui.misc

import com.mojang.blaze3d.vertex.PoseStack
import fr.username404.snowygui.ClickGui
import fr.username404.snowygui.Snowy.Companion.onEvent
import fr.username404.snowygui.config.Configuration
import fr.username404.snowygui.gui.FontUtil
import fr.username404.snowygui.newBox
import io.github.config4k.getValue
import kotlinx.datetime.Clock
import kotlinx.datetime.TimeZone
import kotlinx.datetime.toLocalDateTime
import net.minecraft.client.Minecraft

object Storage {
    val currentTimezone = TimeZone.currentSystemDefault()
    private var oldGamma = 0.0
    private const val redColor = 0x660000
    var clock: Boolean = false; private set
    var hurtCamera: Boolean = true; private set

    private val riskyCheats: Boolean by Configuration.obtained
    fun ClickGui.addComponents() {
        addComps(
            newBox("snowy.clickbox.misc").addButtons(
                "GammaBoost" to {
                    with(Minecraft.getInstance().options) {
                        gamma = if (toggled) {
                            if (gamma >= 1400.0) oldGamma = gamma
                            1400.0
                        } else oldGamma
                    }
                }, "Clock" to { clock = toggled },
            ),
        )
        if (riskyCheats) {
            addComps(
                newBox("snowy.clickbox.risky.camera", color = redColor).addButtons(
                    "NoHurtCamera" to { hurtCamera = !toggled },
                ),
                newBox("snowy.clickbox.risky.movement", color = redColor).addButtons(
                    "NoGravity" to { Minecraft.getInstance().player?.let { it.isNoGravity = toggled } },
                ),
            )
        }
    }
    init {
        onEvent("HudRender") {
            if (clock) {
                with(Clock.System.now().toLocalDateTime(currentTimezone)) {
                    FontUtil.drawScaled(it.first() as PoseStack,
                        "$hour:$minute:${second.let { if (it >= 10) it else "0$it" }}",
                        5.0, 5.0,
                        0.85F, color = 0xe69500
                    )
                }
            }
        }
    }
}